//Source file: PAMEventInfo.java
//Date: June 2006
//Presence and Availability Management for 3GPP TS 29.198-14 V6.3.0, Release 6

package org.csapi.jr.se.pam;

/**
 * This is a tagged choice of data elements that specifies the event data provided by applications while registering.
 *
 */
public final class PAMEventInfo implements java.io.Serializable {

    private PAMEventName _discriminator = null;
    private java.lang.Object _object;

    /**
     * Creates a new PAMEventInfo.
     * Tagged choice of data elements always have empty constructors
     */ 
    public PAMEventInfo() {}

    /**
     * This method returns the discriminator.
     * 
     * @return a PAMEventName value 
     * @exception InvalidUnionAccessorException if an error occurs 
     */ 
    public PAMEventName getDiscriminator() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator == null) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return _discriminator;
    }

    /**
     * This method returns a IdentityCreated
     * 
     * @return  a org.csapi.jr.se.pam.PAMICEventData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMICEventData getIdentityCreated() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_IDENTITY_CREATED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMICEventData) _object);
    }

    /**
     * This method sets a IdentityCreated
     * 
     * @param value a org.csapi.jr.se.pam.PAMICEventData value
     */
    public void setIdentityCreated(org.csapi.jr.se.pam.PAMICEventData value) {
        _discriminator = PAMEventName.PAM_CE_IDENTITY_CREATED;
        _object = value;
    }

    /**
     * This method returns a IdentityDeleted
     * 
     * @return  a org.csapi.jr.se.pam.PAMIDEventData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMIDEventData getIdentityDeleted() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_IDENTITY_DELETED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMIDEventData) _object);
    }

    /**
     * This method sets a IdentityDeleted
     * 
     * @param value a org.csapi.jr.se.pam.PAMIDEventData value
     */
    public void setIdentityDeleted(org.csapi.jr.se.pam.PAMIDEventData value) {
        _discriminator = PAMEventName.PAM_CE_IDENTITY_DELETED;
        _object = value;
    }

    /**
     * This method returns a GroupMembershipChanged
     * 
     * @return  a org.csapi.jr.se.pam.PAMGMCEventData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMGMCEventData getGroupMembershipChanged() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_GROUP_MEMBERSHIP_CHANGED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMGMCEventData) _object);
    }

    /**
     * This method sets a GroupMembershipChanged
     * 
     * @param value a org.csapi.jr.se.pam.PAMGMCEventData value
     */
    public void setGroupMembershipChanged(org.csapi.jr.se.pam.PAMGMCEventData value) {
        _discriminator = PAMEventName.PAM_CE_GROUP_MEMBERSHIP_CHANGED;
        _object = value;
    }

    /**
     * This method returns a AgentCreated
     * 
     * @return  a org.csapi.jr.se.pam.PAMACEventData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMACEventData getAgentCreated() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_AGENT_CREATED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMACEventData) _object);
    }

    /**
     * This method sets a AgentCreated
     * 
     * @param value a org.csapi.jr.se.pam.PAMACEventData value
     */
    public void setAgentCreated(org.csapi.jr.se.pam.PAMACEventData value) {
        _discriminator = PAMEventName.PAM_CE_AGENT_CREATED;
        _object = value;
    }

    /**
     * This method returns a AgentDeleted
     * 
     * @return  a org.csapi.jr.se.pam.PAMADEventData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMADEventData getAgentDeleted() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_AGENT_DELETED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMADEventData) _object);
    }

    /**
     * This method sets a AgentDeleted
     * 
     * @param value a org.csapi.jr.se.pam.PAMADEventData value
     */
    public void setAgentDeleted(org.csapi.jr.se.pam.PAMADEventData value) {
        _discriminator = PAMEventName.PAM_CE_AGENT_DELETED;
        _object = value;
    }

    /**
     * This method returns a AgentAssigned
     * 
     * @return  a org.csapi.jr.se.pam.PAMAAEventData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMAAEventData getAgentAssigned() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_AGENT_ASSIGNED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMAAEventData) _object);
    }

    /**
     * This method sets a AgentAssigned
     * 
     * @param value a org.csapi.jr.se.pam.PAMAAEventData value
     */
    public void setAgentAssigned(org.csapi.jr.se.pam.PAMAAEventData value) {
        _discriminator = PAMEventName.PAM_CE_AGENT_ASSIGNED;
        _object = value;
    }

    /**
     * This method returns a AgentUnassigned
     * 
     * @return  a org.csapi.jr.se.pam.PAMAUEventData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMAUEventData getAgentUnassigned() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_AGENT_UNASSIGNED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMAUEventData) _object);
    }

    /**
     * This method sets a AgentUnassigned
     * 
     * @param value a org.csapi.jr.se.pam.PAMAUEventData value
     */
    public void setAgentUnassigned(org.csapi.jr.se.pam.PAMAUEventData value) {
        _discriminator = PAMEventName.PAM_CE_AGENT_UNASSIGNED;
        _object = value;
    }

    /**
     * This method returns a CapabilityChanged
     * 
     * @return  a org.csapi.jr.se.pam.PAMCCEventData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMCCEventData getCapabilityChanged() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_CAPABILITY_CHANGED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMCCEventData) _object);
    }

    /**
     * This method sets a CapabilityChanged
     * 
     * @param value a org.csapi.jr.se.pam.PAMCCEventData value
     */
    public void setCapabilityChanged(org.csapi.jr.se.pam.PAMCCEventData value) {
        _discriminator = PAMEventName.PAM_CE_CAPABILITY_CHANGED;
        _object = value;
    }

    /**
     * This method returns a AgentCapabilityPresenceSet
     * 
     * @return  a org.csapi.jr.se.pam.PAMACPSEventData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMACPSEventData getAgentCapabilityPresenceSet() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_AGENT_CAPABILITY_PRESENCE_SET) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMACPSEventData) _object);
    }

    /**
     * This method sets a AgentCapabilityPresenceSet
     * 
     * @param value a org.csapi.jr.se.pam.PAMACPSEventData value
     */
    public void setAgentCapabilityPresenceSet(org.csapi.jr.se.pam.PAMACPSEventData value) {
        _discriminator = PAMEventName.PAM_CE_AGENT_CAPABILITY_PRESENCE_SET;
        _object = value;
    }

    /**
     * This method returns a AgentPresenceSet
     * 
     * @return  a org.csapi.jr.se.pam.PAMAPSEventData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMAPSEventData getAgentPresenceSet() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_AGENT_PRESENCE_SET) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMAPSEventData) _object);
    }

    /**
     * This method sets a AgentPresenceSet
     * 
     * @param value a org.csapi.jr.se.pam.PAMAPSEventData value
     */
    public void setAgentPresenceSet(org.csapi.jr.se.pam.PAMAPSEventData value) {
        _discriminator = PAMEventName.PAM_CE_AGENT_PRESENCE_SET;
        _object = value;
    }

    /**
     * This method returns a IdentityPresenceSet
     * 
     * @return  a org.csapi.jr.se.pam.PAMIPSEventData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMIPSEventData getIdentityPresenceSet() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_IDENTITY_PRESENCE_SET) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMIPSEventData) _object);
    }

    /**
     * This method sets a IdentityPresenceSet
     * 
     * @param value a org.csapi.jr.se.pam.PAMIPSEventData value
     */
    public void setIdentityPresenceSet(org.csapi.jr.se.pam.PAMIPSEventData value) {
        _discriminator = PAMEventName.PAM_CE_IDENTITY_PRESENCE_SET;
        _object = value;
    }

    /**
     * This method returns a AvailabilityChanged
     * 
     * @return  a org.csapi.jr.se.pam.PAMAVCEventData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMAVCEventData getAvailabilityChanged() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_AVAILABILITY_CHANGED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMAVCEventData) _object);
    }

    /**
     * This method sets a AvailabilityChanged
     * 
     * @param value a org.csapi.jr.se.pam.PAMAVCEventData value
     */
    public void setAvailabilityChanged(org.csapi.jr.se.pam.PAMAVCEventData value) {
        _discriminator = PAMEventName.PAM_CE_AVAILABILITY_CHANGED;
        _object = value;
    }

    /**
     * This method returns a WatchersChanged
     * 
     * @return  a org.csapi.jr.se.pam.PAMWCEventData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMWCEventData getWatchersChanged() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_WATCHERS_CHANGED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMWCEventData) _object);
    }

    /**
     * This method sets a WatchersChanged
     * 
     * @param value a org.csapi.jr.se.pam.PAMWCEventData value
     */
    public void setWatchersChanged(org.csapi.jr.se.pam.PAMWCEventData value) {
        _discriminator = PAMEventName.PAM_CE_WATCHERS_CHANGED;
        _object = value;
    }


    /**
     * This method will receive the discriminator as a parameter and will set _object to null
     * 
     * @param discriminator a PAMEventName value 
     */ 
    public void setUndefined(PAMEventName discriminator) {
        _discriminator = discriminator;
        _object = null;
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }
        if(!(o instanceof PAMEventInfo)) {
            return false;
        } else {
            PAMEventInfo pAMEventInfo= (PAMEventInfo)o;
            if(!(this._object.equals(pAMEventInfo._object))){
                return false;
            } else {
                if(!(this._discriminator.equals(pAMEventInfo._discriminator))){
                    return false;
                }
            }
            if (this.hashCode() != o.hashCode()) {
                return false;
            }
            return true;
        }
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // PAMEventInfo

