//Source file: PAMGMCEventData.java
//Date: June 2006
//Presence and Availability Management for 3GPP TS 29.198-14 V6.3.0, Release 6

package org.csapi.jr.se.pam;

/**
 * This is a Sequence of Data Elements to specify the input data for subscribing to group membership changes. The event is registered for changes in any of the named groups. If no groups are named, then the event is registered for all groups.
 * 
 */
public final class PAMGMCEventData implements java.io.Serializable {

    private String[] groupName;
    private String[] groupType;

    /**
     * Creates a new PAMGMCEventData instance.
     */
    public PAMGMCEventData () {}

    /**
     * Creates a new PAMGMCEventData instance.
     * @param _groupName   Specifies the name of the group for which the change is to be notified. Can be an empty array if notifications are required for any group.
     * @param _groupType   Specifies the type of the group for which this notification is requested if the groupName is specified as an empty array. Can be an empty array if notification required for groups of any type.
     */
    public PAMGMCEventData (String[] _groupName, String[] _groupType) {

        this.groupName = _groupName;
        this.groupType = _groupType;
    }

    /**
     * This method returns a groupName.
     * 
     * @return a String[] value
     */
    public String[] getGroupName() {
        return groupName;
    }

    /**
     * This method returns a groupType.
     * 
     * @return a String[] value
     */
    public String[] getGroupType() {
        return groupType;
    }


    /**
     * This method sets a groupName.
     */ 
    public void setGroupName(String[] groupName) {
        this.groupName = groupName;
    }

    /**
     * This method sets a groupType.
     */ 
    public void setGroupType(String[] groupType) {
        this.groupType = groupType;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof PAMGMCEventData)) {
            return false;
        } 
        PAMGMCEventData pAMGMCEventData = (PAMGMCEventData) o;
        if(!(this.groupName == pAMGMCEventData.groupName))  {
            return false;
        }
        if(!(this.groupType == pAMGMCEventData.groupType))  {
            return false;
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // PAMGMCEventData

