//Source file: PAMICEventData.java
//Date: June 2006
//Presence and Availability Management for 3GPP TS 29.198-14 V6.3.0, Release 6

package org.csapi.jr.se.pam;

/**
 * This is a Sequence of Data Elements to specify the input data for subscribing to identity creations. The event is registered for changes in any agents of the named type. If no identity types are named, then the event is registered for all identity types.
 * 
 */
public final class PAMICEventData implements java.io.Serializable {

    private String[] identityType;

    /**
     * Creates a new PAMICEventData instance.
     */
    public PAMICEventData () {}

    /**
     * Creates a new PAMICEventData instance.
     * @param _identityType   Contains the names of the identities that have been created.
     */
    public PAMICEventData (String[] _identityType) {

        this.identityType = _identityType;
    }

    /**
     * This method returns a identityType.
     * 
     * @return a String[] value
     */
    public String[] getIdentityType() {
        return identityType;
    }


    /**
     * This method sets a identityType.
     */ 
    public void setIdentityType(String[] identityType) {
        this.identityType = identityType;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof PAMICEventData)) {
            return false;
        } 
        PAMICEventData pAMICEventData = (PAMICEventData) o;
        if(!(this.identityType == pAMICEventData.identityType))  {
            return false;
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // PAMICEventData

