//Source file: PAMICNotificationData.java
//Date: June 2006
//Presence and Availability Management for 3GPP TS 29.198-14 V6.3.0, Release 6

package org.csapi.jr.se.pam;

/**
 * This is a Sequence of Data Elements to specify the data that is provided in the notifications for identity creation events.
 * 
 */
public final class PAMICNotificationData implements java.io.Serializable {

    private String[] identities;

    /**
     * Creates a new PAMICNotificationData instance.
     */
    public PAMICNotificationData () {}

    /**
     * Creates a new PAMICNotificationData instance.
     * @param _identities   Contains the names of the identities that have been created.
     */
    public PAMICNotificationData (String[] _identities) {

        this.identities = _identities;
    }

    /**
     * This method returns a identities.
     * 
     * @return a String[] value
     */
    public String[] getIdentities() {
        return identities;
    }


    /**
     * This method sets a identities.
     */ 
    public void setIdentities(String[] identities) {
        this.identities = identities;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof PAMICNotificationData)) {
            return false;
        } 
        PAMICNotificationData pAMICNotificationData = (PAMICNotificationData) o;
        if(!(this.identities == pAMICNotificationData.identities))  {
            return false;
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // PAMICNotificationData

