//Source file: PAMNotificationInfo.java
//Date: June 2006
//Presence and Availability Management for 3GPP TS 29.198-14 V6.3.0, Release 6

package org.csapi.jr.se.pam;

/**
 * This is a tagged choice of data elements that specifies the notification data provided to the applications for each event.
 *
 */
public final class PAMNotificationInfo implements java.io.Serializable {

    private PAMEventName _discriminator = null;
    private java.lang.Object _object;

    /**
     * Creates a new PAMNotificationInfo.
     * Tagged choice of data elements always have empty constructors
     */ 
    public PAMNotificationInfo() {}

    /**
     * This method returns the discriminator.
     * 
     * @return a PAMEventName value 
     * @exception InvalidUnionAccessorException if an error occurs 
     */ 
    public PAMEventName getDiscriminator() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator == null) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return _discriminator;
    }

    /**
     * This method returns a IdentityCreatedNotify
     * 
     * @return  a org.csapi.jr.se.pam.PAMICNotificationData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMICNotificationData getIdentityCreatedNotify() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_IDENTITY_CREATED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMICNotificationData) _object);
    }

    /**
     * This method sets a IdentityCreatedNotify
     * 
     * @param value a org.csapi.jr.se.pam.PAMICNotificationData value
     */
    public void setIdentityCreatedNotify(org.csapi.jr.se.pam.PAMICNotificationData value) {
        _discriminator = PAMEventName.PAM_CE_IDENTITY_CREATED;
        _object = value;
    }

    /**
     * This method returns a IdentityDeletedNotify
     * 
     * @return  a org.csapi.jr.se.pam.PAMIDNotificationData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMIDNotificationData getIdentityDeletedNotify() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_IDENTITY_DELETED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMIDNotificationData) _object);
    }

    /**
     * This method sets a IdentityDeletedNotify
     * 
     * @param value a org.csapi.jr.se.pam.PAMIDNotificationData value
     */
    public void setIdentityDeletedNotify(org.csapi.jr.se.pam.PAMIDNotificationData value) {
        _discriminator = PAMEventName.PAM_CE_IDENTITY_DELETED;
        _object = value;
    }

    /**
     * This method returns a GroupMembershipChangedNotify
     * 
     * @return  a org.csapi.jr.se.pam.PAMGMCNotificationData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMGMCNotificationData getGroupMembershipChangedNotify() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_GROUP_MEMBERSHIP_CHANGED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMGMCNotificationData) _object);
    }

    /**
     * This method sets a GroupMembershipChangedNotify
     * 
     * @param value a org.csapi.jr.se.pam.PAMGMCNotificationData value
     */
    public void setGroupMembershipChangedNotify(org.csapi.jr.se.pam.PAMGMCNotificationData value) {
        _discriminator = PAMEventName.PAM_CE_GROUP_MEMBERSHIP_CHANGED;
        _object = value;
    }

    /**
     * This method returns a AgentCreatedNotify
     * 
     * @return  a org.csapi.jr.se.pam.PAMACNotificationData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMACNotificationData getAgentCreatedNotify() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_AGENT_CREATED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMACNotificationData) _object);
    }

    /**
     * This method sets a AgentCreatedNotify
     * 
     * @param value a org.csapi.jr.se.pam.PAMACNotificationData value
     */
    public void setAgentCreatedNotify(org.csapi.jr.se.pam.PAMACNotificationData value) {
        _discriminator = PAMEventName.PAM_CE_AGENT_CREATED;
        _object = value;
    }

    /**
     * This method returns a AgentDeletedNotify
     * 
     * @return  a org.csapi.jr.se.pam.PAMADNotificationData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMADNotificationData getAgentDeletedNotify() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_AGENT_DELETED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMADNotificationData) _object);
    }

    /**
     * This method sets a AgentDeletedNotify
     * 
     * @param value a org.csapi.jr.se.pam.PAMADNotificationData value
     */
    public void setAgentDeletedNotify(org.csapi.jr.se.pam.PAMADNotificationData value) {
        _discriminator = PAMEventName.PAM_CE_AGENT_DELETED;
        _object = value;
    }

    /**
     * This method returns a AgentAssignedNotify
     * 
     * @return  a org.csapi.jr.se.pam.PAMAANotificationData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMAANotificationData getAgentAssignedNotify() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_AGENT_ASSIGNED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMAANotificationData) _object);
    }

    /**
     * This method sets a AgentAssignedNotify
     * 
     * @param value a org.csapi.jr.se.pam.PAMAANotificationData value
     */
    public void setAgentAssignedNotify(org.csapi.jr.se.pam.PAMAANotificationData value) {
        _discriminator = PAMEventName.PAM_CE_AGENT_ASSIGNED;
        _object = value;
    }

    /**
     * This method returns a AgentUnassignedNotify
     * 
     * @return  a org.csapi.jr.se.pam.PAMAUNotificationData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMAUNotificationData getAgentUnassignedNotify() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_AGENT_UNASSIGNED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMAUNotificationData) _object);
    }

    /**
     * This method sets a AgentUnassignedNotify
     * 
     * @param value a org.csapi.jr.se.pam.PAMAUNotificationData value
     */
    public void setAgentUnassignedNotify(org.csapi.jr.se.pam.PAMAUNotificationData value) {
        _discriminator = PAMEventName.PAM_CE_AGENT_UNASSIGNED;
        _object = value;
    }

    /**
     * This method returns a CapabilityChangedNotify
     * 
     * @return  a org.csapi.jr.se.pam.PAMCCNotificationData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMCCNotificationData getCapabilityChangedNotify() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_CAPABILITY_CHANGED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMCCNotificationData) _object);
    }

    /**
     * This method sets a CapabilityChangedNotify
     * 
     * @param value a org.csapi.jr.se.pam.PAMCCNotificationData value
     */
    public void setCapabilityChangedNotify(org.csapi.jr.se.pam.PAMCCNotificationData value) {
        _discriminator = PAMEventName.PAM_CE_CAPABILITY_CHANGED;
        _object = value;
    }

    /**
     * This method returns a AgentCapabilityPresenceSetNotify
     * 
     * @return  a org.csapi.jr.se.pam.PAMACPSNotificationData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMACPSNotificationData getAgentCapabilityPresenceSetNotify() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_AGENT_CAPABILITY_PRESENCE_SET) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMACPSNotificationData) _object);
    }

    /**
     * This method sets a AgentCapabilityPresenceSetNotify
     * 
     * @param value a org.csapi.jr.se.pam.PAMACPSNotificationData value
     */
    public void setAgentCapabilityPresenceSetNotify(org.csapi.jr.se.pam.PAMACPSNotificationData value) {
        _discriminator = PAMEventName.PAM_CE_AGENT_CAPABILITY_PRESENCE_SET;
        _object = value;
    }

    /**
     * This method returns a AgentPresenceSetNotify
     * 
     * @return  a org.csapi.jr.se.pam.PAMAPSNotificationData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMAPSNotificationData getAgentPresenceSetNotify() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_AGENT_PRESENCE_SET) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMAPSNotificationData) _object);
    }

    /**
     * This method sets a AgentPresenceSetNotify
     * 
     * @param value a org.csapi.jr.se.pam.PAMAPSNotificationData value
     */
    public void setAgentPresenceSetNotify(org.csapi.jr.se.pam.PAMAPSNotificationData value) {
        _discriminator = PAMEventName.PAM_CE_AGENT_PRESENCE_SET;
        _object = value;
    }

    /**
     * This method returns a IdentityPresenceSetNotify
     * 
     * @return  a org.csapi.jr.se.pam.PAMIPSNotificationData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMIPSNotificationData getIdentityPresenceSetNotify() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_IDENTITY_PRESENCE_SET) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMIPSNotificationData) _object);
    }

    /**
     * This method sets a IdentityPresenceSetNotify
     * 
     * @param value a org.csapi.jr.se.pam.PAMIPSNotificationData value
     */
    public void setIdentityPresenceSetNotify(org.csapi.jr.se.pam.PAMIPSNotificationData value) {
        _discriminator = PAMEventName.PAM_CE_IDENTITY_PRESENCE_SET;
        _object = value;
    }

    /**
     * This method returns a AvailabilityChangedNotify
     * 
     * @return  a org.csapi.jr.se.pam.PAMAVCNotificationData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMAVCNotificationData getAvailabilityChangedNotify() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_AVAILABILITY_CHANGED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMAVCNotificationData) _object);
    }

    /**
     * This method sets a AvailabilityChangedNotify
     * 
     * @param value a org.csapi.jr.se.pam.PAMAVCNotificationData value
     */
    public void setAvailabilityChangedNotify(org.csapi.jr.se.pam.PAMAVCNotificationData value) {
        _discriminator = PAMEventName.PAM_CE_AVAILABILITY_CHANGED;
        _object = value;
    }

    /**
     * This method returns a WatchersChangedNotify
     * 
     * @return  a org.csapi.jr.se.pam.PAMWCNotificationData value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.PAMWCNotificationData getWatchersChangedNotify() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMEventName.PAM_CE_WATCHERS_CHANGED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.PAMWCNotificationData) _object);
    }

    /**
     * This method sets a WatchersChangedNotify
     * 
     * @param value a org.csapi.jr.se.pam.PAMWCNotificationData value
     */
    public void setWatchersChangedNotify(org.csapi.jr.se.pam.PAMWCNotificationData value) {
        _discriminator = PAMEventName.PAM_CE_WATCHERS_CHANGED;
        _object = value;
    }


    /**
     * This method will receive the discriminator as a parameter and will set _object to null
     * 
     * @param discriminator a PAMEventName value 
     */ 
    public void setUndefined(PAMEventName discriminator) {
        _discriminator = discriminator;
        _object = null;
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }
        if(!(o instanceof PAMNotificationInfo)) {
            return false;
        } else {
            PAMNotificationInfo pAMNotificationInfo= (PAMNotificationInfo)o;
            if(!(this._object.equals(pAMNotificationInfo._object))){
                return false;
            } else {
                if(!(this._discriminator.equals(pAMNotificationInfo._discriminator))){
                    return false;
                }
            }
            if (this.hashCode() != o.hashCode()) {
                return false;
            }
            return true;
        }
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // PAMNotificationInfo

