//Source file: PAMPreferenceData.java
//Date: June 2006
//Presence and Availability Management for 3GPP TS 29.198-14 V6.3.0, Release 6

package org.csapi.jr.se.pam;

/**
 * This is a tagged choice of data elements that specifies the preference data. The data depends on the type of preference being specified.
 *
 */
public final class PAMPreferenceData implements java.io.Serializable {

    private PAMPreferenceType _discriminator = null;
    private java.lang.Object _object;

    /**
     * Creates a new PAMPreferenceData.
     * Tagged choice of data elements always have empty constructors
     */ 
    public PAMPreferenceData() {}

    /**
     * This method returns the discriminator.
     * 
     * @return a PAMPreferenceType value 
     * @exception InvalidUnionAccessorException if an error occurs 
     */ 
    public PAMPreferenceType getDiscriminator() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator == null) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return _discriminator;
    }

    /**
     * This method returns a ExternalControlInterface
     * 
     * @return  a org.csapi.jr.se.pam.access.AppPAMPreferenceCheck value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.pam.access.AppPAMPreferenceCheck getExternalControlInterface() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != PAMPreferenceType.PAM_EXTERNAL_CONTROL) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.pam.access.AppPAMPreferenceCheck) _object);
    }

    /**
     * This method sets a ExternalControlInterface
     * 
     * @param value a org.csapi.jr.se.pam.access.AppPAMPreferenceCheck value
     */
    public void setExternalControlInterface(org.csapi.jr.se.pam.access.AppPAMPreferenceCheck value) {
        _discriminator = PAMPreferenceType.PAM_EXTERNAL_CONTROL;
        _object = value;
    }


    /**
     * This method will receive the discriminator as a parameter and will set _object to null
     * 
     * @param discriminator a PAMPreferenceType value 
     */ 
    public void setUndefined(PAMPreferenceType discriminator) {
        _discriminator = discriminator;
        _object = null;
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }
        if(!(o instanceof PAMPreferenceData)) {
            return false;
        } else {
            PAMPreferenceData pAMPreferenceData= (PAMPreferenceData)o;
            if(!(this._object.equals(pAMPreferenceData._object))){
                return false;
            } else {
                if(!(this._discriminator.equals(pAMPreferenceData._discriminator))){
                    return false;
                }
            }
            if (this.hashCode() != o.hashCode()) {
                return false;
            }
            return true;
        }
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // PAMPreferenceData

