//Source file: PamUnknownCapabilityException.java
//Date: June 2006
//Presence and Availability Management for 3GPP TS 29.198-14 V6.3.0, Release 6

package org.csapi.jr.se.pam;

/**
 * Indicates that a supplied capability is not a capability of the requested agent, or has not been defined. No attributes are affected
 *
 */
public class PamUnknownCapabilityException extends org.csapi.jr.se.pam.PamException {

    private Throwable _cause = null;

    public PamUnknownCapabilityException() {
        super(); 
    }

    public PamUnknownCapabilityException(String message) {
        super(message); 
    }

    public PamUnknownCapabilityException(String message, Throwable cause) {
        super(message); 
        _cause = cause;
    }

    public PamUnknownCapabilityException(Throwable cause) {
        _cause = cause; 
    }

    public Throwable getCause() {
        return _cause;
    } 

} // PamUnknownCapabilityException

