//Source file: PamUnknownTypeException.java
//Date: June 2006
//Presence and Availability Management for 3GPP TS 29.198-14 V6.3.0, Release 6

package org.csapi.jr.se.pam;

/**
 * Indicates that the named type does not exist / indicates that the named identity/agent has not been associated with the named type / indicates that a specified type name has not been defined as an agent type
 *
 */
public class PamUnknownTypeException extends org.csapi.jr.se.pam.PamException {

    private Throwable _cause = null;

    public PamUnknownTypeException() {
        super(); 
    }

    public PamUnknownTypeException(String message) {
        super(message); 
    }

    public PamUnknownTypeException(String message, Throwable cause) {
        super(message); 
        _cause = cause;
    }

    public PamUnknownTypeException(Throwable cause) {
        _cause = cause; 
    }

    public Throwable getCause() {
        return _cause;
    } 

} // PamUnknownTypeException

