//Source file: PAMAvailability.java
//Date: June 2006
//Presence and Availability Management for 3GPP TS 29.198-14 V6.3.0, Release 6

package org.csapi.jr.se.pam.access;

/**
 * This interface represents a PAMAvailability.<BR>
 *
 */
public interface PAMAvailability extends org.csapi.jr.se.Service {

    /**
     * Invokes the getAvailability() method on the Parlay Gateway.
     */
    org.csapi.jr.se.pam.PAMAvailabilityProfile[] getAvailability(
           java.lang.String                identity,
           org.csapi.jr.se.pam.PAMContext pamContext,
           java.lang.String[]              attributeNames,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the getPreference() method on the Parlay Gateway.
     */
    org.csapi.jr.se.pam.PAMPreferenceData getPreference(
           java.lang.String                identity,
           org.csapi.jr.se.pam.PAMContext pamContext,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the setPreference() method on the Parlay Gateway.
     */
    void setPreference(
           java.lang.String                identity,
           org.csapi.jr.se.pam.PAMContext pamContext,
           java.lang.String                operation,
           org.csapi.jr.se.pam.PAMPreferenceData newPreference,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

}
