//Source file: PAMIdentityPresence.java
//Date: June 2006
//Presence and Availability Management for 3GPP TS 29.198-14 V6.3.0, Release 6

package org.csapi.jr.se.pam.access;

/**
 * This interface represents a PAMIdentityPresence.<BR>
 *
 */
public interface PAMIdentityPresence extends org.csapi.jr.se.Service {

    /**
     * Invokes the setIdentityPresence() method on the Parlay Gateway.
     */
    void setIdentityPresence(
           java.lang.String                identity,
           java.lang.String                identityType,
           org.csapi.jr.se.pam.PAMAttribute[] attributes,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the setIdentityPresenceExpiration() method on the Parlay Gateway.
     */
    void setIdentityPresenceExpiration(
           java.lang.String                identity,
           java.lang.String                identityType,
           java.lang.String[]              attributeNames,
           long                            expiresIn,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the getIdentityPresence() method on the Parlay Gateway.
     */
    org.csapi.jr.se.pam.PAMAttribute[] getIdentityPresence(
           java.lang.String                identity,
           java.lang.String                identityType,
           java.lang.String[]              attributeNames,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

}
