//Source file: PAMAgentManagement.java
//Date: June 2006
//Presence and Availability Management for 3GPP TS 29.198-14 V6.3.0, Release 6

package org.csapi.jr.se.pam.provisioning;

/**
 * This interface represents a PAMAgentManagement.<BR>
 *
 */
public interface PAMAgentManagement extends org.csapi.jr.se.Service {

    /**
     * Invokes the createAgent() method on the Parlay Gateway.
     */
    void createAgent(
           java.lang.String                agentName,
           java.lang.String[]              agentTypes,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamAgentExistsException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the deleteAgent() method on the Parlay Gateway.
     */
    void deleteAgent(
           java.lang.String                agentName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAgentException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the isAgent() method on the Parlay Gateway.
     */
    boolean isAgent(
           java.lang.String                agentName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the enableCapabilities() method on the Parlay Gateway.
     */
    void enableCapabilities(
           java.lang.String                agentName,
           java.lang.String[]              capabilities,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAgentException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the disableCapabilities() method on the Parlay Gateway.
     */
    void disableCapabilities(
           java.lang.String                agentName,
           java.lang.String[]              capabilities,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAgentException,
       org.csapi.jr.se.pam.PamNoCapabilityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listEnabledCapabilities() method on the Parlay Gateway.
     */
    java.lang.String[] listEnabledCapabilities(
           java.lang.String                agentName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAgentException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listAllCapabilities() method on the Parlay Gateway.
     */
    java.lang.String[] listAllCapabilities(
           java.lang.String                agentName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAgentException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the isCapableOf() method on the Parlay Gateway.
     */
    boolean isCapableOf(
           java.lang.String                agentName,
           java.lang.String                capability,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAgentException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the associateTypes() method on the Parlay Gateway.
     */
    void associateTypes(
           java.lang.String                agentName,
           java.lang.String[]              agentTypes,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAgentException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamTypeAssociatedException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the disassociateTypes() method on the Parlay Gateway.
     */
    void disassociateTypes(
           java.lang.String                agentName,
           java.lang.String[]              agentTypes,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAgentException,
       org.csapi.jr.se.pam.PamDisassociatedTypeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listTypesOfAgent() method on the Parlay Gateway.
     */
    java.lang.String[] listTypesOfAgent(
           java.lang.String                agentName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAgentException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the hasType() method on the Parlay Gateway.
     */
    boolean hasType(
           java.lang.String                agentName,
           java.lang.String                typeName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAgentException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the getAgentAttributes() method on the Parlay Gateway.
     */
    org.csapi.jr.se.pam.PAMAttribute[] getAgentAttributes(
           java.lang.String                agentName,
           java.lang.String                agentType,
           java.lang.String[]              attributeNames,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAgentException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the setAgentAttributes() method on the Parlay Gateway.
     */
    void setAgentAttributes(
           java.lang.String                agentName,
           java.lang.String                agentType,
           org.csapi.jr.se.pam.PAMAttribute[] attributes,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAgentException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamUnknownAttributesException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

}
