//Source file: PAMCapabilityManagement.java
//Date: June 2006
//Presence and Availability Management for 3GPP TS 29.198-14 V6.3.0, Release 6

package org.csapi.jr.se.pam.provisioning;

/**
 * This interface represents a PAMCapabilityManagement.<BR>
 *
 */
public interface PAMCapabilityManagement extends org.csapi.jr.se.Service {

    /**
     * Invokes the createCapabilityAttribute() method on the Parlay Gateway.
     */
    void createCapabilityAttribute(
           org.csapi.jr.se.pam.PAMAttributeDef pAttribute,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamAttributeExistsException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the deleteCapabilityAttribute() method on the Parlay Gateway.
     */
    void deleteCapabilityAttribute(
           java.lang.String                attributeName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the getCapabilityAttributeDefinition() method on the Parlay Gateway.
     */
    org.csapi.jr.se.pam.PAMAttributeDef getCapabilityAttributeDefinition(
           java.lang.String                attributeName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listAllCapabilityAttributes() method on the Parlay Gateway.
     */
    java.lang.String[] listAllCapabilityAttributes(
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the createCapability() method on the Parlay Gateway.
     */
    void createCapability(
           java.lang.String                capabilityName,
           java.lang.String[]              attributeNames,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamTypeExistsException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the deleteCapability() method on the Parlay Gateway.
     */
    void deleteCapability(
           java.lang.String                capabilityName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listCapabilities() method on the Parlay Gateway.
     */
    java.lang.String[] listCapabilities(
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the addCapabilityAttributes() method on the Parlay Gateway.
     */
    void addCapabilityAttributes(
           java.lang.String                capabilityName,
           java.lang.String[]              attributeNames,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamAttributeExistsException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the removeCapabilityAttributes() method on the Parlay Gateway.
     */
    void removeCapabilityAttributes(
           java.lang.String                capabilityName,
           java.lang.String[]              attributeNames,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listCapabilityAttributes() method on the Parlay Gateway.
     */
    java.lang.String[] listCapabilityAttributes(
           java.lang.String                capabilityName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the assignCapabilitiesToType() method on the Parlay Gateway.
     */
    void assignCapabilitiesToType(
           java.lang.String                agentType,
           java.lang.String[]              capabilities,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamUnknownCapabilityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the unassignCapabilitiesFromType() method on the Parlay Gateway.
     */
    void unassignCapabilitiesFromType(
           java.lang.String                agentType,
           java.lang.String[]              capabilities,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamUnknownCapabilityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listCapabilitiesOfType() method on the Parlay Gateway.
     */
    java.lang.String[] listCapabilitiesOfType(
           java.lang.String                agentType,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

}
