//Source file: PAMProvisioningManager.java
//Date: June 2006
//Presence and Availability Management for 3GPP TS 29.198-14 V6.3.0, Release 6

package org.csapi.jr.se.pam.provisioning;

/**
 * This interface represents a PAMProvisioningManager.<BR>
 *
 */
public interface PAMProvisioningManager extends org.csapi.jr.se.Service {

    /**
     * Invokes the getAuthToken() method on the Parlay Gateway.
     */
    byte[] getAuthToken(
           org.csapi.jr.se.Attribute[] askerData)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the obtainInterface() method on the Parlay Gateway.
     */
    org.csapi.jr.se.CsapiInterface obtainInterface(
           java.lang.String                interfaceName)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnavailableInterfaceException;

    /**
     * Invokes the getAccessControl() method on the Parlay Gateway.
     */
    org.csapi.jr.se.pam.PAMAccessControlData getAccessControl(
           java.lang.String                identity,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the setAccessControl() method on the Parlay Gateway.
     */
    void setAccessControl(
           java.lang.String                identity,
           java.lang.String                operation,
           org.csapi.jr.se.pam.PAMAccessControlData newAccessControl,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

}
